%define kmod_name spl

%bcond_with     debug
%bcond_with     debug_log
%bcond_with     debug_kmem
%bcond_with     debug_kmem_tracking
%bcond_with     atomic_spinlocks


Name:           %{kmod_name}-kmod

Version:        0.6.1
Release:        1%{?dist}
Summary:        Kernel module(s)

Group:          System Environment/Kernel
License:        GPLv2+
URL:            http://zfsonlinux.org/
Source0:        %{kmod_name}-%{version}.tar.gz
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# The developments headers will conflict with the dkms packages.
Conflicts:      %{kmod_name}-dkms

BuildRequires: kabi-whitelists %kernel_module_package_buildreqs
%kernel_module_package -n %{kmod_name}

%description
This package contains the kernel modules required to emulate
several interfaces provided by the Solaris kernel.

%package devel
Summary:	Solaris Porting Layer Headers and Symbols
Group:		Development/Libraries
Requires:	kernel-devel-uname-r = %kverrel

%description devel
The %{name}-devel package contains the header files and Module{s}.symvers
symbols needed for building additional modules which use %{name}.

%prep
%setup -q -c -T -a 0 -n spl-%{version}

for flavor in %flavors_to_build ; do
%ifarch %{ix86}
    cp -a spl-%{version} _kmod_build_${flavor}
%else
    cp -a spl-%{version} _kmod_build_${flavor}
%endif
done

%if %{with debug}
    %define debug --enable-debug
%else
    %define debug --disable-debug
%endif

%if %{with debug_log}
    %define debug_log --enable-debug-log
%else
    %define debug_log --disable-debug-log
%endif

%if %{with debug_kmem}
    %define debug_kmem --enable-debug-kmem
%else
    %define debug_kmem --disable-debug-kmem
%endif

%if %{with debug_kmem_tracking}
    %define debug_kmem_tracking --enable-debug-kmem-tracking
%else
    %define debug_kmem_tracking --disable-debug-kmem-tracking
%endif

%if %{with atomic_spinlocks}
    %define atomic_spinlocks --enable-atomic-spinlocks
%else
    %define atomic_spinlocks --disable-atomic-spinlocks
%endif


%build
for flavor in %flavors_to_build ; do
	pushd _kmod_build_${flavor}
	%configure --with-config=kernel \
		--with-linux=%{kernel_source $flavor} --with-linux-obj=%{kernel_source $flavor} \
		%{debug} \
		%{debug_log} \
		%{debug_kmem} \
		%{debug_kmem_tracking} \
		%{atomic_spinlocks}
	make
	popd
done

%install
rm -rf $RPM_BUILD_ROOT
for flavor in %flavors_to_build ; do
	#/lib/modules/%kverrel${flavor%default}/extra/spl
	make -C _kmod_build_${flavor} DESTDIR=$RPM_BUILD_ROOT install
	pushd $RPM_BUILD_ROOT/lib/modules/%kverrel${flavor%default}
	find extra
	mv extra/splat/*ko extra/spl/
	rmdir extra/splat
	popd
done

%clean
rm -rf $RPM_BUILD_ROOT

%files devel
%defattr(-,root,root)
%{_prefix}/src/*/*

%changelog
* Fri Sep 14 2012 Josko Plazonic <plazonic@math.princeton.edu>
- initial build
